#include <avr/io.h>
void delay_us(unsigned char time_us)
{
	register unsigned char i;
	for(i=0;i<time_us;i++) //4 cycle
	{
		asm volatile("PUSH R0"); //2 cycle
		asm volatile("POP R0"); //2 cycle
		asm volatile("PUSH R0"); //2 cycle
		asm volatile("POP R0"); //2 cycle
		asm volatile("PUSH R0"); //2 cycle
		asm volatile("POP R0"); //2 cycle
		// Sum = 16 cycle=1 us for 16MHz
	}
}
void delay_ms(unsigned int time_ms)
{
	register unsigned int i;
	for(i=0;i<time_ms;i++) //4 cycle
	{
		delay_us(250);
		delay_us(250);
		delay_us(250);
		delay_us(250);
	}
}
int main(void)
{
	unsigned char state,pressed,old_pressed;
	long i;

	DDRA = 0x01;
	DDRD = 0xf0;
	state=0;
	pressed=0;
	old_pressed=0;
	while(1){
		if (!(PINA & 0x02))
		{
			old_pressed=pressed;
			pressed=1;
		}
		else
		{
			old_pressed=pressed;
			pressed=0;
		}
		delay_ms(10);
		if (!old_pressed && pressed)
		{
			state=!state;
		}
		
		if (state==1)
		{
			PORTA = 0x0;
		}
		else
		{
			PORTA = 0x0f;
		}
	 }
}								


